####################################
# All Rights Reserved
# Copyright (c) 2022-2023 fixyldev
####################################

#update
execute as @r unless score @s lastdeathlocation.update matches 1 run tellraw @s ["","\n",{"text":"Last Death Location - 0.4.0","color":"red"},"\n","\n",{"text":"   /trigger lastdeathlocation","color":"gold","clickEvent":{"action":"suggest_command","value":"/trigger lastdeathlocation"}},"\n",{"text":"      shows your \"Last Death Location\" in the chat","color":"yellow"},"\n",{"text":"   /trigger lastdeathlocation.settings","color":"gold","clickEvent":{"action":"suggest_command","value":"/trigger lastdeathlocation.settings"}},"\n",{"text":"      shows the settings menu in the chat","color":"yellow"},"\n"]
execute as @r unless score @s lastdeathlocation.update matches 1 run scoreboard players set @s lastdeathlocation.update 1

#register
execute as @r unless score @s lastdeathlocation.registered matches 0.. run scoreboard players add #count lastdeathlocation.registered 1
execute as @r unless score @s lastdeathlocation.registered matches 0.. run scoreboard players operation @s lastdeathlocation.registered = #count lastdeathlocation.registered

#gamerule
execute unless score #doImmediateRespawn lastdeathlocation.gamerule matches 0..1 store result score #doImmediateRespawn lastdeathlocation.gamerule run gamerule doImmediateRespawn
execute store result score #doImmediateRespawn.check lastdeathlocation.gamerule run gamerule doImmediateRespawn
execute if score #doImmediateRespawn.check lastdeathlocation.gamerule matches 1 run gamerule doImmediateRespawn false

#marker
execute as @a[scores={lastdeathlocation.death=1..},gamemode=!spectator] at @s run summon minecraft:area_effect_cloud ~ ~0.5 ~ {CustomNameVisible:1b,Duration:6000,Tags:["lastdeathlocation"],CustomName:'{"translate":"deathScreen.title","italic":true}'}
execute as @a[scores={lastdeathlocation.death=1..},gamemode=!spectator] at @s unless score @e[tag=lastdeathlocation,distance=..5,sort=nearest,limit=1] lastdeathlocation.marker matches 0.. run scoreboard players operation @e[tag=lastdeathlocation,distance=..5,sort=nearest,limit=1] lastdeathlocation.marker = @s lastdeathlocation.registered
execute at @e[tag=lastdeathlocation] run particle minecraft:firework ~ ~ ~ 0.2 0.2 0.2 0.025 1 normal
execute as @e[tag=lastdeathlocation] at @s if entity @r[distance=..5,gamemode=!spectator] unless entity @r[distance=..5,nbt={Health:0f}] if score @r[distance=..5,gamemode=!spectator] lastdeathlocation.registered = @s lastdeathlocation.marker run particle minecraft:totem_of_undying ~ ~1 ~ 0.2 0 0.2 0.1 25
execute as @e[tag=lastdeathlocation] at @s if entity @r[distance=..5,gamemode=!spectator] unless entity @r[distance=..5,nbt={Health:0f}] if score @r[distance=..5,gamemode=!spectator] lastdeathlocation.registered = @s lastdeathlocation.marker run playsound minecraft:entity.experience_orb.pickup player @a[distance=..20] ~ ~ ~ 1 1 1
execute as @e[tag=lastdeathlocation] at @s if entity @r[distance=..5,gamemode=!spectator] unless entity @r[distance=..5,nbt={Health:0f}] if score @r[distance=..5,gamemode=!spectator] lastdeathlocation.registered = @s lastdeathlocation.marker run kill @s

#lastdeathlocation.manual
scoreboard players enable @a lastdeathlocation
execute as @r[scores={lastdeathlocation=..-1}] run scoreboard players set @s lastdeathlocation 1
execute as @r[scores={lastdeathlocation=1..}] run function lastdeathlocation:chat/message

#lastdeathlocation
execute as @a[scores={lastdeathlocation.death=1..}] run function lastdeathlocation:chat/message

#settings
scoreboard players enable @a lastdeathlocation.settings
execute as @r[scores={lastdeathlocation.settings=-24..-1}] run function lastdeathlocation:chat/language
execute as @r[scores={lastdeathlocation.settings=..-25}] run scoreboard players set @s lastdeathlocation.settings 1
execute as @r[scores={lastdeathlocation.settings=1..}] run function lastdeathlocation:chat/settings
